<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Наблюдатель для создания отправлений.
 */
class Shop_Order_Observer_Dispatch
{
	/**
	 * Режим откладки.
	 *
	 * @var boolean
	 */
	static protected $_debug = FALSE;

	/**
	 * Навешивает наблюдатель.
	 *
	 * @return void
	 */
	static public function attach()
	{
		Core_Event::attach('shop_order.onAfterPaid', array(__CLASS__, 'onAfterPaid'));
	}

	/**
	 * Событие оплаты заказа.
	 *
	 * @param  Shop_Order_Model  $oShopOrder
	 * @param  array  $aArgs
	 * @return void
	 */
	static public function onAfterPaid(Shop_Order_Model $oShopOrder, array $aArgs)
	{
		// Клонируем объект, это необходимо для того, чтобы
		// реальному объекту не было установлено описание 
		$oClonedShopOrder = clone $oShopOrder;
		// $oClonedShopOrder->description = 'Косметика';

		// Устанавливаем идентификатор для получения доп. свойства заказа
		$oClonedShopOrder->id = $oShopOrder->id;

		switch ($oShopOrder->shop_delivery_id)
		{
			// // Pickpoint
			// case 6:
			// 	Shop_Order_Dispatcher::factory('pickpoint')
			// 		->debug(self::$_debug)
			// 		->dispatch($oClonedShopOrder);
			// break;

			// // Hermes
			// case 11:
			// 	Shop_Order_Dispatcher::factory('hermes')
			// 		->debug(self::$_debug)
			// 		->dispatch($oClonedShopOrder);
			// break;
		}
	}
}